#include <iostream.h>
#include <iomanip.h>
#include "float32.h"

long Float32::Sign()
{
	return this->u32.asLongInteger & MASK32_SIGN ? 1 : 0;
}


long Float32::Exponent()
{
	return (this->u32.asLongInteger & MASK32_EXPONENT) >> 23;
}

void Float32::PrintFraction()
{
	unsigned long mask = MASK32_1ST_MANTISSA;
        int i;

        if (this->u32.asLongInteger)
        	cout << "1.";
        else
        	cout << "0.";


        for (i = 0; i < 23; i++)
        {
        	if (this->u32.asLongInteger & mask)
                	cout << "1";
                else
                	cout << "0";
                mask = mask >> 1;
        }
}

void Float32::Print()
{
	cout
        << "floating point = " << this->Fp()
        << " 32-bit representation = " << hex << setfill('0') << setw(8) << this->Li() << dec << endl
        << "sign = " << this->Sign()
        << " biased exponent = " << this->Exponent()
        << " unbiased exponent = " << this->Exponent() - 127 << endl
        << "fraction = ";
        this->PrintFraction();
        cout << endl << endl;
}




