#include <iostream.h>
#include <iomanip.h>
#include "float64.h"


long Float64::Sign()
{
	return this->u64.asLongInteger[0] & MASK64HI_SIGN ? 1 : 0;
}

long Float64::Exponent()
{
	return (this->u64.asLongInteger[1] & MASK64HI_EXPONENT) >> 20;
}

void Float64::PrintFraction()
{
	unsigned long mask;
        int i;

        if (this->u64.asLongInteger[0] || this->u64.asLongInteger[1])
        	cout << "1.";
        else
        	cout << "0.";

        mask = MASK64HI_1ST_MANTISSA;
        for (i = 0; i < 20; i++)
        {
        	if (this->u64.asLongInteger[1] & mask)
                	cout << "1";
                else
                	cout << "0";
                mask = mask >> 1;
        }

        mask = MASK64LOW_1ST_MANTISSA;
        for (i = 0; i < 32; i++)
        {
        	if (this->u64.asLongInteger[0] & mask)
                	cout << "1";
                else
                	cout << "0";
                mask = mask >> 1;
        }

}

void Float64::Print()
{
	cout
        << "floating point = " << this->Fp()
        << " 64-bit representation = " << hex << setfill('0') << setw(8) << this->LiHi() << this->LiLow() << dec << endl
        << "sign = " << this->Sign()
        << " biased exponent = " << this->Exponent()
        << " unbiased exponent = " << this->Exponent() - 1023 << endl
        << "fraction = ";
        this->PrintFraction();
        cout << endl << endl;
}
